from jax.config import config
config.update("jax_enable_x64", True)
import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
from matplotlib.patches import Rectangle
import numpy as np
import pickle


init_sys = 4

file = open( "vd_init/vd"+str(init_sys)+".pickle", "rb" )
X,Xfi=pickle.load(file)
file.close()


# file = open( "../vd_"+str(init_sys)+".pickle", "rb" )


plt.figure(figsize=(60,25))
plt.clf()
ax = plt.subplot(1,1, 1,aspect='equal')
ax.set_ylim(-7.1, 7.1)
ax.set_xlim(-7.1, 7.1)
ax.set_aspect('equal', 'box')

rec_x=X[0,0]-0.25
rec_y=X[0,1]-0.25


# plt.axvline(x=0,c='grey')
# plt.axhline(y=0,c='grey')
ax.scatter( *zip(*X),c='k',s=400 )
ax.scatter( *zip(*X[Xfi]),c='r',s=400 )
# ax.scatter(x_s,y_s,c='b',s=200 )
plt.tight_layout()
at = Rectangle((rec_x, rec_y), 0.5, 0.5, color='grey',alpha=0.2)
ax.add_patch(at)
plt.xticks([])
plt.yticks([])
ax.spines['top'].set_visible(False)
ax.spines['right'].set_visible(False)
ax.spines['bottom'].set_visible(False)
ax.spines['left'].set_visible(False)



plt.savefig("../vd"+str(init_sys)+"_0/"+"vd4_saddle_init"".png", bbox_inches='tight')
# plt.show()

#
file_name="../vd"+str(init_sys)+"_0/vd_"+str(init_sys)+"_prms.pickle"
file = open(file_name, 'rb')
prms=pickle.load(file)
N_f=4
for fs in range(1,N_f):

    # load states
    # print(fs)
    file_x = open(prms.str_file + "x_stats_" + str(fs) + ".pickle", "rb")
    # print(file)
    [out_s,t,X_t,Y_t,wgts,run_dimmer,S_card]=pickle.load(file_x)

    file_x.close()
    plot_dimmer = run_dimmer is True and S_card>0
    if plot_dimmer:
        file_d = open(prms.str_file + "d_stats_" + str(fs) + ".pickle", "rb")
        [U_0,t, exit_code,dimmer_iters,x_index1,x_final] = pickle.load(file_d)
        file_d.close()
        print(fs,exit_code)
        # plot success
        if exit_code==0:
            plt.clf()
            ax = plt.subplot(1, 1, 1, aspect='equal')
            ax.set_ylim(-7.1, 7.1)
            ax.set_xlim(-7.1, 7.1)
            ax.set_aspect('equal', 'box')
            rec_x = X[0, 0] - 0.25
            rec_y = X[0, 1] - 0.25

        # plt.axvline(x=0,c='grey')
        # plt.axhline(y=0,c='grey')
            ax.scatter(*zip(*x_index1), c='r', s=400)
            fixed_index=np.arange(0,X.shape[0])
            fixed_index=np.setdiff1d(fixed_index,Xfi)

            ax.scatter(*zip(*X[fixed_index]), c='k', s=400)
            plt.tight_layout()
            plt.xticks([])
            plt.yticks([])
            ax.spines['top'].set_visible(False)
            ax.spines['right'].set_visible(False)
            ax.spines['bottom'].set_visible(False)
            ax.spines['left'].set_visible(False)
            at = Rectangle((rec_x, rec_y), 0.5, 0.5, color='grey', alpha=0.2)
            ax.add_patch(at)
            plt.savefig("../vd"+str(init_sys)+"_0/"+"vd4_saddle_"+str(fs)+".png", bbox_inches='tight')
            file.close()